package DrawTexts;

import java.awt.*;
import java.awt.image.*;
import java.util.StringTokenizer;  //For multilined texts.


import Globals.*;
import Ightaria.*;






/**<pre> 

These are subwindows of the screen:

a        N       b
W        C       E
c        S       d


</pre>*/

public class SPad{

  //---------------------------------------------
  // C O N S T A N T S 
  //- - - - - - - - - - - - - - - - - - - - - - -

  public static final              Color BRIGHT_BLUED = new Color( 100<<16|200<<8|255 );
  private static final       Color DEFAULT_FORE_COLOR = new Color( 255<<8|255 );
  private static final Color DEFAULT_BACKGROUND_COLOR = new Color(0);

  private static final        int DEFAULT_STRING_STEP = 13;



  //- - - - - - - - - - - - - - - - - - - - - - -
  // Implicit Collection
  //
  // These parameters effectively describe 
  // static part of class SPad as implicit collection of 
  // Scratch Pads.
  //. . . . . . . . . . . . . . . . . . . . . . . .

  /** When used, none_ means "no pad" */
  public static final int none_ = -1; 

  public static final int a_ = 0;
  public static final int W_ = 1;
  public static final int c_ = 2;

  public static final int N_ = 3;
  public static final int C_ = 4;
  public static final int S_ = 5;

  public static final int b_ = 6;
  public static final int E_ = 7;
  public static final int d_ = 8;

  public static final int P_ = 9;
  

  /** For detection self test 
      do1b Make this more consistent */
  public static final int F_ = 10;


 public static SPad[] sPad = new SPad[10];


  //. . . . . . . . . . . . . . . . . . . . . . . .
  // Implicit Collection
  //- - - - - - - - - - - - - - - - - - - - - - -


  //- - - - - - - - - - - - - - - - - - - - - - -
  // C O N S T A N T S 
  //---------------------------------------------







  public              Color foreTextColor;
  public              Color backgroundColor;
  public            boolean drawBorders;
   

                                                 private int Ix;
  /** Total dimensions.                      */  public  int xL, yL;
  /** Low level boundary for terminal output */  private int yLTerminal;      
                                                 public  int xR, yR;

  
  public Graphics g;
  public  Image img;
  public  ImageObserver iobs;
  private Image imgToDraw;
  private ImageObserver iobsToDraw;

  private Font ftDefault;
  public  Font        ft;
  private FontMetrics fm;

  //Vertical string size:
  private int mStringStep;  

  private int mNextString;



  //V a r i a b l e s   f o r   s c r o l l i n g   p r o c e d u r e s:
  private    Color scrollColor;
  private     Font scrollFont;
  private      int scrollStartIx;
  private      int scrollAllowedIxBlock;
  private      int scrollStartScreenTextLine;
  private String[] scrollString;
  private      int scrollStringBodyLength;
  private      int scrollStringHeight;






  //= = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
  // Talk zone
  //- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

  /** Talk Zone fields and 
      methods used when user 
      prints. Methods drawn 
      over all graphics, when 
      graphics is finished.
      Location:
  */                             public int talkX, talkY, talkW, talkH;

  /** Keeps user's input line.
      1000 chars should be 
      enough for line. 
  */                             public StringBuffer sb = new StringBuffer(1000);

  /** Focus color */             public Color focusColor;
  /** Talk color */              public Color focusForeColor;
  /** Talk font */               private Font talkFont;

  //- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
  // Talk zone
  //= = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =

















 // C O M M O N   S T A T I C   G R A P H I C S

 //static private      Graphics parentGraphics;
 //static private         Image parentImage;
 //static private ImageObserver parentImageObserver; //do1 make null?

 //- - - - - - - - - - - - - - - - - - - - - - - - - -
 // Implicit Collection variables and initialization
 //. . . . . . . . . . . . . . . . . . . . . . . . . .

 /** Default draw sequence. Center is in background. */  
 public static int[] drawSequence;


 //= = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
 // Talk zone
 //- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
 /** Which pad has focus. */    public static int focusIx; 
 //= = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =






 /** initialize implicit-collection of SPads */
 public static void internalInit() { 

        int[] aux_ds = {
            C_,
            a_, N_, b_, W_, E_,
            c_, S_, d_, P_
        };
        drawSequence = aux_ds;
         
 
        //GS.con("Initializing Scratch Pads ... ");
        sPad[a_] = new SPad(a_, 0,    0, 200, 200);
        sPad[W_] = new SPad(W_, 0,  200, 200, 250);
        sPad[c_] = new SPad(c_, 0,  450, 250, 250);

        sPad[N_] = new SPad(N_, 200,  0, 600, 100);
        sPad[C_] = new SPad(C_, 200,100, 600, 400);
        sPad[S_] = new SPad(S_, 250,500, 500, 200); 

        sPad[b_] = new SPad(b_, 800,  0, 200, 200);
        sPad[E_] = new SPad(E_, 800,200, 200, 250);
        sPad[d_] = new SPad(d_, 750,450, 250, 250);

        sPad[P_] = new SPad(F_,   0,  0,1000, 700);

        //Patch: No borders for main pad:
        sPad[C_].drawBorders = false;

       //===================================================================
       // Talk zone for implicit collection:
       //-------------------------------------------------------------------
       /** Which pad has focus. */    focusIx = none_; 
       //===================================================================

 }
 
 //. . . . . . . . . . . . . . . . . . . . . . . . . .
 // Implicit Collection variables and initialization
 //- - - - - - - - - - - - - - - - - - - - - - - - - -






 public static void drawPads() {
        for ( int i=0; i<sPad.length; i++) {
              int iX = drawSequence[i];
              if( iX != none_ ) {
                  if( P_ == iX ) {
                      //Only this method is alloed yet for Parent:
                      sPad[iX].paintIfNotNull();
                  } else {
                    //parentGraphics.drawImage( 
                    sPad[P_].g.drawImage( 
                        sPad[iX].img,
                        sPad[iX].xR, 
                        sPad[iX].yR, 
                        null //do1 was: parentImageObserver
                    );
                  }
              }
          }

 }

 public static void paintTalk() {
        for ( int i=0; i<SPad.sPad.length; i++) {
              int ii = SPad.drawSequence[i];
              if( ii != none_ ) SPad.sPad[ii].talkPrint();
        }  
 }

 //---------------------------------------------------------
 // Implicit Collection
 //=========================================================








  /** The idea is to be able to preset dimensions before 
      graphics context is even yet known.
  */
  public SPad( int Ix, int xR, int yR, int xL, int yL ) {

             //do1 What if this font does not exist?:
             ftDefault = new Font ("Courier New", Font.PLAIN, 12 );
                    ft = ftDefault;
       backgroundColor = DEFAULT_BACKGROUND_COLOR;
         foreTextColor = DEFAULT_FORE_COLOR;
           drawBorders = true;

       this.Ix = Ix;
       this.xL = xL;
       this.yL = yL;
       this.xR = xR;
       this.yR = yR;
       yLTerminal = yL - 20;
       mStringStep = DEFAULT_STRING_STEP;
       mNextString = mStringStep + 2;


       //= = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
       // Talk zone
       //- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

       focusColor = new Color(50<<8|50);
       focusForeColor = new Color(200<<16|250<<8|80);
       talkFont = new Font ("Arial", Font.PLAIN, 14 );

       //- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
       // Talk zone
       //= = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =

  }



  //==============================================================
  //  S u p p l y   a n d   r e l e a s e   r e s o u r c e s
  //--------------------------------------------------------------
  //public static void supplyParentGraphicsToCollection(
  //              Image parentImage_P,
  //              Graphics parentGraphics_P,
  //              ImageObserver parentImageObserver_P) {

  //       parentImage         = parentImage_P;
  //       parentGraphics      = parentGraphics_P;
  //       parentImageObserver = parentImageObserver_P;
  //
  //}       
  public static void supplyGraphicsToCollection(
                           int iX, 
                           Image img, 
                           Graphics g,
                           ImageObserver iobs,
                           Font dflFont) {
         sPad[iX].img = img;
         sPad[iX].supplyGraphics(g);
         sPad[iX].iobs = iobs;
         if( dflFont != null ) {
             SPad.sPad[iX].setDefaultFont(dflFont);
         }
  }
  public static void releaseGraphicsFromCollection() {
         for ( int i=0; i<sPad.length; i++)
               sPad[i].releaseGraphics();
         //parentGraphics.dispose();
         //parentGraphics = null;
         //parentImage.flush();
         //parentImage = null;
         //parentImageObserver = null;
  }

  public void supplyGraphics (Graphics g) {
         //GS.con("Supplying Graphics to Scratch Pad " + Ix );
         this.g = g;
         setFont(ftDefault);
         fm = g.getFontMetrics();
         Clear();  //do1b is this not too early to draw?
  }
  public void releaseGraphics () {
         fm = null;
         g.dispose();
         g  = null;
         img.flush();
         img = null;
         iobs = null;
  }
  //--------------------------------------------------------------
  //  S u p p l y   a n d   r e l e a s e   r e s o u r c e s
  //==============================================================




  /** Font can be edited only after graphics is supplied. */
  public void setFont(Font ft) {
         this.ft = ft;
         g.setFont(ft);
         fm = g.getFontMetrics();
  }

  /** Set Default and Current font */
  public void setDefaultFont(Font ft) {
         ftDefault = ft;
         setFont(ftDefault);
  }

  /** Restore changed current font */
  public void restoreToDefaultFont() {
         setFont(ftDefault);
         //mStringStep = DEFAULT_STRING_STEP;
  }





  /** Clears and prepares screen for drawing. 
      Clears terminal and non-terminal areas.
      Border is cleared also.
  */
  public void Clear() {
         //GS.con("Clearing Image Area ... ");
         g.setColor(backgroundColor);
         g.fillRect(0,0,xL,yL);
         DrewBorder();
         mNextString = mStringStep + 2;
         //GS.con("Cleared ...");
  }


  /** Prepares screen for drawing. */
  public void DrewBorder() {
         g.setColor(DEFAULT_FORE_COLOR);
         if( drawBorders ) {
             g.drawLine(0, 0, 0, yL-1);
             g.drawLine(0, 0, xL-1, 0);
             g.drawLine(xL-1, 0, xL-1, yL-1);
             g.drawLine(0, yL-1, xL-1, yL-1);
         }
  }




  //===================================================================
  // Talk zone
  //-------------------------------------------------------------------
 
  /** Set SPad to listen to user's input */
  public void setFocus() {
         sb.setLength(0);
         g.setColor(focusColor);
         g.fillRect( 3,yLTerminal, xL-4, yL - yLTerminal - 1 );
         sb.append("Speak up here ... ");
         talkPrint();
         sb.setLength(0);
  }      

  public void removeFocus() {
         g.setColor(backgroundColor);
         g.fillRect( 3,yLTerminal, xL-4, yL - yLTerminal - 1 );
         //talkPrint();
  }      



  /** Appends char to buffer if space available. 
      Returns false if exceeds x-dimension. 
  */
  synchronized public boolean addChar(char c) {
          if( sb.length() < 999 ) { 
              //.do1 Possibly slow
              g.setFont(talkFont);
              fm = g.getFontMetrics();
              int len = fm.stringWidth(sb.toString());
              g.setFont(ft);
              //GS.con( "Permitted len=" + len);
              if( len > xL - 20 ) return false;
              sb.append(c);
              return true;
          } else {
            return false;
          }
  }

  public boolean removeChar() {
          if( sb.length() > 0 ) { 
              sb.setLength(sb.length()-1);
              return true;
          } else {
            return false;
          }
  }

  

  public void talkPrint() {
         if( Ix != focusIx ) return;
         g.setColor(focusColor);
         g.fillRect( 3,yLTerminal, xL-4, yL - yLTerminal - 1 );
         if( sb.length() > 0 ) {
             g.setColor(focusForeColor);
             g.setFont(talkFont);
             g.drawString(sb.toString(),3,yL-5);
             g.setFont(ft);
         }
  }
  //-------------------------------------------------------------------
  // Talk zone
  //===================================================================














  //=====================================================================
  //  These are terminal style printers. Simple but not
  //  very productive.
  //---------------------------------------------------------------------


  /** Clear and write from top */
  public void wrc(String s) {
         ClearTerminal();
         wr(s);
  }

  /** Print string to the next position, redraw
      from the top, if no space:
  */
  public void wr(String s) {
          if( mNextString > yLTerminal - 3 ) {
              ClearTerminal();
          }
          g.setColor(foreTextColor);
          g.drawString(s, 3, mNextString);
          mNextString += mStringStep;
  }

  /** Display multilined text with \n as line separator */
  public void wrm(String s) {
         g.setColor(foreTextColor);
         StringTokenizer st = new StringTokenizer(s,"\n");
         while(st.hasMoreTokens()) {
               String s0 = st.nextToken();
               g.drawString(s0, 3, mNextString);
               mNextString += mStringStep;
               if( mNextString > yLTerminal - 3 ) break;
         }
         st = null;
  }

  /** Display multilined text with \n as line separator 
      starting from startFromLine from the top.
      startFromLine <= 1 starts from the first line. */
  public void wrm(String s, int startFromLine) {
         mNextString = 2 + mStringStep;
         for(int i=1; i<startFromLine; i++ ){
             mNextString += mStringStep;
         }
         wrm(s);
  }




  //==================================================================================
  //   S e t   w i n d o w,   d i s p l a y,   a n d   s c r o l l   m e t h o d s
  //----------------------------------------------------------------------------------

  /** Numeration begins from startFromLine=1. 
      Array's startIx begins from 0.
      sBodyLength - length of sub array of non-null strings intended for scrolling.
      String will be stashed and can be reused for scrolling.
  */
  public void setAndScroll(String[] s, int sBodyLength, int startIx, int startFromLine,
                           Font ft, Color cl) {
         scrollAllowedIxBlock = 0; //Master flag
         if( s          == null ) return;
         if( s.length   == 0    ) return;
         if( s[0]       == null ) return;
         setScrollGraphics(ft,cl);
         scrollStartIx   = startIx;
         scrollStartScreenTextLine = startFromLine;

         //Prepare:
         FontMetrics fm = g.getFontMetrics();
         scrollStringHeight = fm.getHeight();
         mNextString = 2 + scrollStringHeight * scrollStartScreenTextLine;
         scrollAllowedIxBlock = (( yLTerminal - mNextString - 3 ) / scrollStringHeight) - 1;
         if( scrollAllowedIxBlock < 1 ) return;
         scrollString    = s;
         scrollStringBodyLength = sBodyLength;
         //GS.con("Text length set to= " + scrollString.length );
         doScrollString(0);
  }

  public void setScrollGraphics( Font ft, Color cl ) {
              scrollColor = cl;
              scrollFont  = ft;
  }

  public void doScrollString(int direction) {

         if(scrollAllowedIxBlock<1) return; //Silently leave.

         //Prepare:
         mNextString = 2 + scrollStringHeight * scrollStartScreenTextLine;

         //Advance:
         switch(direction) {
            case  0:
            case  1:
            case -1: scrollStartIx += direction;
                     break;
            case  2: scrollStartIx += scrollAllowedIxBlock;
                     break;
            case -2: scrollStartIx -= scrollAllowedIxBlock;
         }
        
         //Protect:
         if(scrollStartIx<0) scrollStartIx=0;
         //Allow at least one line:
         if(scrollStringBodyLength <= scrollStartIx ) scrollStartIx = scrollStringBodyLength-1;
         int allowedIndex = scrollStartIx + scrollAllowedIxBlock - 1;
         if(scrollStringBodyLength <= allowedIndex) allowedIndex = scrollStringBodyLength-1;
         
         //Do draw: 
         setFont(scrollFont); 
         g.setColor(scrollColor);
         //if( direction !=0 ) {
         //    GS.con("Start=" + scrollStartIx + " End=" + allowedIndex + " direction=" + direction);
         //}
         for(int i=scrollStartIx; i<=allowedIndex; i++ ){
             //if(scrollString[i] == null) break;
             g.drawString(scrollString[i], 3, mNextString);
             mNextString += scrollStringHeight;
         }
         restoreTextColor();
         restoreToDefaultFont();

  }

  //----------------------------------------------------------------------------------
  //   S e t   w i n d o w,   d i s p l a y,   a n d   s c r o l l   m e t h o d s
  //==================================================================================




  /** Sets backgroundColor to terminal area.
      If pad has focus, then focus area is not touched.
      If no focus, all space of pad is cleared.
  */
  public void ClearTerminal() {
         g.setColor(backgroundColor);
         int toWhichToClear = yL-2;  //2 because we start from pos 1.
         if( focusIx == Ix  ) toWhichToClear = yLTerminal-2;
         g.fillRect(1,1,xL-2,toWhichToClear);
         mNextString = mStringStep + 2;
  }

  public void ClearTerminalFromCurrentPosition() {
         g.setColor(backgroundColor);
         g.fillRect(1,mNextString,xL-2,yLTerminal-mNextString);
         mNextString = mStringStep + 2;
  }

  /** It does extra step along y, and restores bk. col. par. */
  public void ClearTerminalFromCurrentPosition(Color c) {
         g.setColor(c);
         g.fillRect(1,mNextString-1,xL-2,yLTerminal-mNextString+1);
         backgroundColor = DEFAULT_BACKGROUND_COLOR;
         g.setColor(backgroundColor);
  }





  /** Skip n lines and prints nothing */
  public void skipLines(int n) {
         mNextString +=n*mStringStep;
  }

  /** Starts print from first line */
  public void fromTopLine(String s) {
         mNextString = mStringStep + 2;
         wr(s);
  }
  //---------------------------------------------------------------------
  //  These are terminal style printers. Simple but not
  //  very productive.
  //=====================================================================


  public void restoreTextColor(){
         foreTextColor = DEFAULT_FORE_COLOR;
         g.setColor(foreTextColor);
  }


  public        int paintImgYPosition;
  private final int paintImgYPositionStep = 20;

  /** Return true if image not null to block text scroll */
  public boolean scrollImage(int direction) {
         if( imgToDraw == null ) return false;
         //Advance:
         switch(direction) {
            case  0:
            case  1:
            case -1: paintImgYPosition += (direction * paintImgYPositionStep);
                     break;
            case  2: paintImgYPosition += yL/2;
                     break;
            case -2: paintImgYPosition -= yL/2;
         }
         //do1 exception?:
         int loHeight = imgToDraw.getHeight(iobsToDraw);
         if( loHeight < 20 ) return true;
         if( loHeight - paintImgYPosition < yL/2 ) paintImgYPosition = loHeight - yL/2;
         if( paintImgYPosition < 0 ) paintImgYPosition = 0;
         return true;
  }

  public void setToPaintImage(Image imgP, ImageObserver iobsP) {
         imgToDraw = imgP;
         if( imgP == null ) {
             iobsToDraw = null;
             return;
         }
         iobsToDraw = iobsP;
         paintImgYPosition = 0;
  }



  private void paintIfNotNull() {
         if( imgToDraw == null ) return;

         int imgWidth = imgToDraw.getWidth(iobsToDraw);
         int imgHeight = imgToDraw.getHeight(iobsToDraw);

         int left = xL - imgWidth; 
         if( left < 2 ) { left = 0; } else { left = left/2; }
         int top  = sPad[N_].yL;

         int loX = left+imgWidth-1;
         int loLinesToPaintY = imgHeight-paintImgYPosition;
         //Give little margin of 100 lines on the bottom of Parent Window:
         if( loLinesToPaintY + top > yL-100 ) loLinesToPaintY = yL - 100 - top;
         int loY = top +loLinesToPaintY-1;

         //g.drawImage(imgToDraw,left,top,null); //Simple version.
         g.drawImage( imgToDraw,
                           left,                                 top,       
                            loX,                                 loY, 
                              0,                   paintImgYPosition, 
                     imgWidth-1, paintImgYPosition+loLinesToPaintY-1,
                           null
                    );

         g.setColor(DEFAULT_FORE_COLOR);
         if( drawBorders ) {
             g.drawLine(left, top, left, loY );
             g.drawLine(left, top,  loX, top );
             g.drawLine( loX, top,  loX, loY );
             g.drawLine(left, loY,  loX, loY );
         }
  } 
 
}
