package Ightaria;

import java.awt.*;
import java.lang.Math;

import DrawTexts.*;
import DrawHills.*;
import CalculusAndVectors.*;







public class Terrain extends SingleHill{

/** Location in HF.
    Variable loc is not called inside of this class and
    its children yet, but stores HF-location
    of the Hill. It is designed to be used in external calls to Hill.
*/
protected DVector loc;                    

/** Spherical Dist. to Obs. during the travel.
*/
protected double  oDistance;                

/** Angular spherical Dist. to Obs. during the travel.
*/
protected double  oTau;                     //Angular dist. to Obs.

protected double  oFrontDistance;           //Front distance to observer.
protected double  hOp;                      //Angle coord of Hill's center in Obs basis.

protected double  hFFx, hFFy;
protected double  hFp;                      //Rotation of hill.

protected double  oFp;                      //Rotation of observer.

/** "Horizontal hight" of observer while traveling.
    Belongs to path.
    Not much of importance in navigation, but
    useful in displaying the scene.
*/    
protected static  double oFFz;              

/** This variable speaks for itself. 
    When we draw a Terrain, then this variable is false.
    When we draw a local hill, then it is true:
*/
protected boolean addFunctionToTerrainFunction;


/** oFFMx, oFFMy - are really flat coodinates as they calculated
    by tools of tracking flat path during Vessel's travel.
    Belongs to path, so common to all Hills.
    .do1 "protected static" may be uncommon use of variables.
    Is this use legal? Apparently it works.
*/
protected static  double oFFMx, oFFMy;      

//How to make this function to avoiding accomulation of "inaccuracy"
//when agrument of periodic function is too big?:
static public void setObsFlatPosition( double x, double y ) {
     //was + dx + dy, perhaps better.
     oFFMx = x;  //% terrrainPeriodX; 
     oFFMy = y;  //% terrrainPeriodY; 
}


//=================================================
//Function funTerrain. 
//-------------------------------------------------
static double terrrainPeriodX   = 1000.;
static double terrrainPeriodY   = 1000.;

static final double PI = Math.PI;

static double tWX  = 2. * PI / terrrainPeriodX;  //Basic X-Frequency.
static double tWY  = 2. * PI / terrrainPeriodY;  //Basic Y-Frequency.

static int tNG     = 4;   //Number of Harmonics.
    
static double tPh[][]  = new double [tNG][tNG]; //Phase
static double  tA[][]  = new double [tNG][tNG]; //Amplitude
//-------------------------------------------------
//Function funTerrain. 
//=================================================


//do1 bug?: Method has the same name as class constructor:
/** Function which describes Terrain of the HomeFold.
    This function is a 2-dimensional Fourier series.
    Only tNG Harmonics are used for X and for Y coodinates.
    Details are described in class Terrain source code.
*/
protected int Terrain( double X, double Y ) {
     double zD=0;
     for(int i=tNG-1; i>=0; i--) {
         double sD=0;  //Summ from smallest members. Preserving accuracy.
         for(int j=tNG-1; j>=0; j--) {
             sD += tA[i][j]*Math.cos(tWX*i*X + tWY*j*Y + tPh[i][j]); 
         }
         zD +=sD;
     }
     return (int)zD;
}

  

/** This constructor is probably never used:
*/
public Terrain() {
       super();
}



/** Main constructor. Will be overused by children.super calls.
*/
public Terrain(  
              SPad sp,
              SPad spOwn,
              int ScreenXL,    
              int ScreenYL,
              int center_x,
              int center_y,
              int funN, 
              boolean addFunctionToTerrainFunction
   ) {

        super(  
          sp,
          spOwn,
          ScreenXL,    
          ScreenYL,
          center_x,
          center_y,
          funN
       );
       this.addFunctionToTerrainFunction = addFunctionToTerrainFunction;


       //============================================
       //  Functions
       //--------------------------------------------

       if( funN == funTerrain ) {

           posX=0;   //Perhaps redundant because perhaps code goes around this.
           posY=0;   //Perhaps redundant.

           Xmin =-500;
           Xmax = 500;
           Ymax = 2000;
           Ymin = 40;

           for(int i=0; i<tNG; i++) {
               for(int j=0; j<tNG; j++) {
                   tPh[i][j] = .1 * i * j; 
               }
           }
           for(int i=0; i<tNG; i++) {
               for(int j=0; j<tNG; j++) {
                   tA[i][j] = 20. / (i+j+2); 
               }
           }

           shieldRadius = 0.;
           hillAxisColor = new Color( 200<<16 ); 

           //============================================
           //  Preparations
           //--------------------------------------------
           Xstep  = (Xmax-Xmin+1)/Xsize;
           Ystep  = (Ymax-Ymin+1)/Yrange;
           YMaxMin = Math.max( 
                     Math.max( Math.abs(Ymax),Math.abs(Ymin) ),
                     Math.max( Math.abs(Xmax),Math.abs(Xmin) )
                     );
           //============================================
       }
} //Constructor end.





//^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
//   F U N C T I O N S   S E L E C T E D   B Y   F U N C T.  N U M B E R
//---------------------------------------------------------------------------
public int Fun( int funNumb, int X, int Y ) {
   int Z; 
   if( funTerrain == funNumb ) {
        Z = Terrain( (double) X, (double) Y );
   } else {
        Z = super.Fun( funNumb, X, Y);
   }
   if( addFunctionToTerrainFunction ) Z += Terrain(X+hFFx, Y+hFFy);
   return Z;
}
//---------------------------------------------------------------------------
//   F U N C T I O N S   S E L E C T E D   B Y   F U N C T.  N U M B E R
//^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^


}
